<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/src/MTQueue.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_m_t_queue_8cpp_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">MTQueue.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;MTQueue.h&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;InvalidBlockIndex.h&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;Logging.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">namespace </span>siggen {</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160; </div>
<div class="line"><a name="l00007"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_queue.html#a93ce221a4c3d88f219a8a1e59e53c52f">    7</a></span>&#160;    <a class="code" href="classsiggen_1_1_m_t_queue.html#a93ce221a4c3d88f219a8a1e59e53c52f">MTQueue::MTQueue</a> (<span class="keywordtype">size_t</span> n, <span class="keywordtype">size_t</span> blockSize)</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    {</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;        m_Data.resize(n);</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;        <span class="keywordflow">for</span> (<span class="keyword">auto</span> &amp; data : m_Data)</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        {</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;            std::get&lt;0&gt;(data) = c_InvalidBlockIndex;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;            std::get&lt;1&gt;(data).resize(blockSize);</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        }</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    }</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160; </div>
<div class="line"><a name="l00018"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">   18</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">MTQueue::Enqueue</a> (<span class="keywordtype">size_t</span> blockIndex, std::vector&lt;char&gt; &amp; data)</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    {</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Enqueue request for block=&quot;</span> &lt;&lt; blockIndex &lt;&lt; <span class="stringliteral">&quot; data=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)data.data();</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        std::unique_lock&lt;std::mutex&gt; lock(m_Mutex);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordflow">if</span> (m_Size == m_Data.capacity())</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        {</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;            LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Enqueue failed (full), waiting...&quot;</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;            <span class="comment">// wait until there is any data</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;            m_CondVarWaitForDequeue.wait(lock, [<span class="keyword">this</span>] { <span class="keywordflow">return</span> !<a class="code" href="classsiggen_1_1_m_t_queue.html#acd9c2ada8a8557be458702a03fd1348a">IsFull</a>() || m_Terminate; });</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        }</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keywordtype">size_t</span> <span class="keyword">const</span> idx = m_Size++;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        std::get&lt;0&gt;(m_Data[idx]) = blockIndex;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        std::get&lt;1&gt;(m_Data[idx]).swap(data);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Enqueued idx=&quot;</span> &lt;&lt; idx &lt;&lt; <span class="stringliteral">&quot; block=&quot;</span> &lt;&lt; blockIndex &lt;&lt; <span class="stringliteral">&quot; qdata=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)std::get&lt;1&gt;(m_Data[idx]).data() &lt;&lt; <span class="stringliteral">&quot; data=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)data.data();</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Queue has new element, notifying waiting thread&quot;</span>;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        m_CondVarWaitForEnqueue.notify_one();</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    }</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">   42</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">MTQueue::Dequeue</a> (<span class="keywordtype">size_t</span> &amp; blockIndex, std::vector&lt;char&gt; &amp; data)</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    {</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Dequeue request for block=? data=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)data.data();</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        std::unique_lock&lt;std::mutex&gt; lock(m_Mutex);</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160; </div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordflow">if</span> (m_Size == 0)</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        {</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;            LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Dequeue failed (empty), waiting...&quot;</span>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;            <span class="comment">// wait until there is any data</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;            m_CondVarWaitForEnqueue.wait(lock, [<span class="keyword">this</span>] { <span class="keywordflow">return</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#a38afc32fe3ff55fe04547c3766fc7421">IsWorkReady</a>() || m_Terminate; });</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;            <span class="keywordflow">if</span> (m_Size == 0)</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;            {</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;                <span class="comment">// woken up, but queue still 0, terminating</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;                LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Dequeue woken up, but queue still empty, terminating&quot;</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;                blockIndex = c_InvalidBlockIndex;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;                <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;            }</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        }</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keywordtype">size_t</span> idx = --m_Size;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        blockIndex = std::get&lt;0&gt;(m_Data[idx]);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        data.swap(std::get&lt;1&gt;(m_Data[idx]));</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        LOGMSG(debug) &lt;&lt; <span class="stringliteral">&quot;Dequeued idx=&quot;</span> &lt;&lt; idx &lt;&lt; <span class="stringliteral">&quot; block=&quot;</span> &lt;&lt; blockIndex &lt;&lt; <span class="stringliteral">&quot; qdata=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)std::get&lt;1&gt;(m_Data[idx]).data() &lt;&lt; <span class="stringliteral">&quot; data=&quot;</span> &lt;&lt; (<span class="keywordtype">void</span>*)data.data();</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Dequeued and has room for more, notifying waiting threads&quot;</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        m_CondVarWaitForDequeue.notify_one();</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    }</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno"><a class="line" href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">   74</a></span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">MTQueue::Terminate</a> ()</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    {</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        LOGSCOPE();</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        std::unique_lock&lt;std::mutex&gt; lock(m_Mutex);</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        m_Terminate = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        LOGMSG(trace) &lt;&lt; <span class="stringliteral">&quot;Queue terminating, notifying waiting thread&quot;</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        m_CondVarWaitForDequeue.notify_all();</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        m_CondVarWaitForEnqueue.notify_all();</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    }</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;} <span class="comment">// namespace siggen</span></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_a38afc32fe3ff55fe04547c3766fc7421"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#a38afc32fe3ff55fe04547c3766fc7421">siggen::MTQueue::IsWorkReady</a></div><div class="ttdeci">bool IsWorkReady() const</div><div class="ttdoc">queue has at least one item</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8h_source.html#l00029">MTQueue.h:29</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_a93ce221a4c3d88f219a8a1e59e53c52f"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#a93ce221a4c3d88f219a8a1e59e53c52f">siggen::MTQueue::MTQueue</a></div><div class="ttdeci">MTQueue(size_t n, size_t blockSize)</div><div class="ttdoc">creates queue for n blocks with each block of blockSize bytes</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00007">MTQueue.cpp:7</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_ac47b8a0a7ad4c4334dfed8596aea1651"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#ac47b8a0a7ad4c4334dfed8596aea1651">siggen::MTQueue::Enqueue</a></div><div class="ttdeci">void Enqueue(size_t blockIndex, std::vector&lt; char &gt; &amp;data)</div><div class="ttdoc">enqueues data or waits</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00018">MTQueue.cpp:18</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_acd9c2ada8a8557be458702a03fd1348a"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#acd9c2ada8a8557be458702a03fd1348a">siggen::MTQueue::IsFull</a></div><div class="ttdeci">bool IsFull() const</div><div class="ttdoc">queue is full</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8h_source.html#l00031">MTQueue.h:31</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_a70fe66d834087214efffe789fb296289"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#a70fe66d834087214efffe789fb296289">siggen::MTQueue::Terminate</a></div><div class="ttdeci">void Terminate()</div><div class="ttdoc">sets terminate flag and notify waiting thread(s)</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00074">MTQueue.cpp:74</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_m_t_queue_html_ab383d104dbf22cb80df5fa826c23573b"><div class="ttname"><a href="classsiggen_1_1_m_t_queue.html#ab383d104dbf22cb80df5fa826c23573b">siggen::MTQueue::Dequeue</a></div><div class="ttdeci">void Dequeue(size_t &amp;blockIndex, std::vector&lt; char &gt; &amp;data)</div><div class="ttdoc">dequeues data or waits</div><div class="ttdef"><b>Definition:</b> <a href="_m_t_queue_8cpp_source.html#l00042">MTQueue.cpp:42</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_a065c5f60305fee3569f887679366939.html">src</a></li><li class="navelem"><b>MTQueue.cpp</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
